C SREIW.F
C VERSION 16/07/2018
C IMPROVED CALCULATION OF R(SIGMA)
C STRENGTH(e) WITH INCLINATION AND ARGPER AS PARAMETERS
      IMPLICIT REAL*8 (A-H,J-Z)
      DIMENSION SE(8),SM(8)
      DIMENSION RP(400)
      COMMON PI,TWOPI,NP,NPQ,TETAR,A1,A2,E2,J2,L2,P2
      CHARACTER*50 CABEZAL
      CHARACTER*38 CABEZAL2
      CHARACTER*88 CABEZAL3
      CABEZAL=' pla |p+q|:|p|    a(au)   e     i   omega        '
      CABEZAL2='<R>                  SR = <R> - R_min '
      CABEZAL3=CABEZAL//CABEZAL2
      TWOPI = 8.0D0*DATAN(1.0D0)
      PI=TWOPI/2.D0
      G2R=PI/180.D0
C      KGAUS=0.01720209895D0
C      KG2=KGAUS**2
      CERO  = 0.0D0
      UNO   = 1.0D0
      ERROR=1.D-12
C MEAN SEMIMAJOR AXIS
C DEFINED AS THE a THAT GENERATES THE MEAN MOTION n EQUAL TO THE OBSERVED
C dlambda/dt IN THE NUMERICAL INTEGRATIONS OF THE FULL PLANETART SYSTEM
C BEING lambda = varpi + mean anomaly
      SE(1)=  0.387099D0
      SE(2)=  0.723332D0
      SE(3)=  1.000000D0
      SE(4)=  1.523692D0
      SE(5)=  5.20281D0
      SE(6)=  9.53882D0
      SE(7)= 19.1831D0
      SE(8)= 30.0556D0
C MASSES
      SM(1)=1.66013679D-07
      SM(2)=2.44783833D-06
      SM(3)=3.04043264D-06
      SM(4)=3.22715144D-07
      SM(5)=9.54791938D-04
      SM(6)=2.85885980D-04
      SM(7)=4.36624404D-05
      SM(8)=5.15138902D-05

      WRITE(*,*)'CALCULATES STRENGTH(e,i,w) FOR A GIVEN 2BODY RESONANCE'
      WRITE(*,*)'Based on Gallardo (2006, Icarus 184, 29).'
      WRITE(*,*)'Planets assumed in circular orbits.'
      WRITE(*,*)'Output file: SReiw.out '
      WRITE(*,*)'www.fisica.edu.uy/~gallardo/atlas/'
      WRITE(*,*)'Tabare Gallardo                gallardo@fisica.edu.uy '
      WRITE(*,*)'VERSION 2018  '
      WRITE(*,*)'------------------------------------------------------'

      WRITE(*,*)'PLANET? (Mer=1,...,Nep=8)'
      READ(*,*) INPLA
      WRITE(*,*)'RESONANCE |p+q|,|p| ?'
      WRITE(*,*)'(ex. 2,3 for plutinos; 3,2 for hildas)'
      READ(*,*) NPQ,NP
C NPQ=|P+Q|
C NP=|P|
C ORDER q
      ORQ=DABS(NPQ-NP)
      MAXFAC=NPQ
      IF(NPQ.LE.NP) THEN
        MAXFAC=NP
C IT IS AN EXTERIOR RESONANCE  OR TROJANS
        NPQ=-NPQ
        NP=-NP
      ENDIF
      WRITE(*,*)'ASTEROID''S ELEMENTS:  i,argper'
C sigma is invariant to changes in aries then I take aries at the node
C so longnode(particle)=0
C The planet is in circular and i=0 orbit  then the longper is not defined
C so I take \omega=\Omega=0 for the planet
      READ(*,*)YNC,ARGPER
      LONOD=0.D0
      LOPER=ARGPER
C THE PLANET IS 1
      A1=SE(INPLA)
        E1=0.D0
        J1G=0.D0
        L1G=0.D0
        P1G=0.D0
      J1=J1G*G2R
      L1=L1G*G2R
      P1=P1G*G2R
C PARTICLE IS 2
      A2=A1*((DABS(NP/NPQ))**2/(1.d0+sm(inpla)))**(1.D0/3.D0)
      SALSEM=A2
      OPEN(2,FILE="SReiw.out",STATUS="UNKNOWN",ACCESS="APPEND")
      WRITE(2,*) CABEZAL3
      EXC=0.0D0
      DO 333 IEX=1,99
        EXC=EXC+0.01D0
        E2=EXC
        J2GRA=YNC
        J2=J2GRA*G2R
        L2G=LONOD
        P2G=LOPER
        L2=L2G*G2R
        P2=P2G*G2R
C NUMBER OF EVALUATIONS OF R(sigma) BETWEEN O AND 360 FOR THE
C ESTIMATION OF THE STRENGTH. IN GENERAL 18 IS OK EXCEPT FOR
C NEAR COPLANAR ORBITS
        ISIMAX=180
        if(ync.gt.178.9.or.ync.lt.1.1) then
          isimax=180
        endif
C sigma = (p+q)*lambda_p - p*lambda - q*varpi
        DO ISI=1,ISIMAX
C ACRIT IS SIGMA
        ACRIT=DFLOAT(ISI-1)/DFLOAT(ISIMAX)*360.D0
        TETA=ACRIT+ORQ*LOPER
 901    IF (TETA.GT.360.D0) THEN
          TETA=TETA-360.D0
          GOTO 901
        END IF
C TO RADIANS
        TETAR=TETA*G2R
        RTOT=0.D0
C STEPS OF THE NUMERICAL INTEGRATION FTOM 0 TO 2PI*p IN lambda_pla
C WARNING!!!!!!
C FOR EXOTIC CASES LIKE i=180 AND e=0 IT IS NECESSARY TO TAKE MORE THAN
C 100 POINTS, 300 FOR EXAMPLE IS OK
      ISTEPINT=100
      IF(EXC.LT.0.05) THEN
        ISTEPINT=300
      ENDIF
      IPASOS=ISTEPINT*INT(maxfac)

      DO ILAMBDA1=1,IPASOS
C all possible configurations occur after p revolutions of the planet
C LAMBDA PLANET
      LA1=DFLOAT(ILAMBDA1)/DFLOAT(IPASOS)*TWOPI*DABS(NP)
C MEAN ANOMALY PLANET
      AM1=LA1-P1
 200  IF (AM1.GT.TWOPI) THEN
        AM1=AM1-TWOPI
        GOTO 200
      END IF
 201  IF (AM1.LT.CERO) THEN
        AM1=AM1+TWOPI
        GOTO 201
      END IF
C GIVEN LAMBDA PLANET CALCULATE LAMBDA PARTICLE
      LA2=(NPQ*LA1-TETAR)/NP
C MEAN ANOMALY PARTICLE
      AM2=LA2-P2
 202  IF (AM2.GT.TWOPI) THEN
        AM2=AM2-TWOPI
        GOTO 202
      END IF
 203  IF (AM2.LT.CERO) THEN
        AM2=AM2+TWOPI
        GOTO 203
      END IF
C CRUDE METHOD FOR SOLVING KEPLER FOR PLANET
C JUST IN CASE YOU WANTED TO PUT SOME PLANETARY ECCENTRICITY
      AEX=AM1
 210     AEXN=AM1+E1*DSIN(AEX)
      IF(DABS(AEXN-AEX).GT.ERROR) THEN
        AEX=AEXN
        GOTO 210
      ENDIF
      AEX1=AEXN
C TRUE ANOMALY
      AVE1=DACOS((DCOS(AEX1)-E1)/(UNO-E1*DCOS(AEX1)))
      IF(AM1.GT.PI) AVE1=TWOPI-AVE1
C HELIOCENTRIC DISTANCE
      R1=A1*(UNO-E1*DCOS(AEX1))
C CRUDE METHOD FOR SOLVING KEPLER FOR PARTICLE (ECCENTRIC)
C      AEX=AM2
C 211     AEXN=AM2+E2*DSIN(AEX)
C      IF(DABS(AEXN-AEX).GT.ERROR) THEN
C        AEX=AEXN
C        GOTO 211
C      ENDIF
C      AEX2=AEXN
C SOLVING KEPLER FOR PARTICLE BY CLEVER METHOD
      CALL SOLKEP(E2,AM2,AEX2,INITER)
C TRUE ANOMALY
      AVE2=DACOS((DCOS(AEX2)-E2)/(UNO-E2*DCOS(AEX2)))
      IF(AM2.GT.PI) AVE2=TWOPI-AVE2
C HELIOCENTRIC DISTANCE
      R2=A2*(UNO-E2*DCOS(AEX2))
C RADIUS VECTOR FOR PLANET
      X1=R1*(DCOS(L1)*DCOS(P1-L1+AVE1)-DSIN(L1)*DSIN(P1-L1+AVE1)
     **DCOS(J1))
      Y1=R1*(DSIN(L1)*DCOS(P1-L1+AVE1)+DCOS(L1)*DSIN(P1-L1+AVE1)
     **DCOS(J1))
      Z1=R1*DSIN(P1-L1+AVE1)*DSIN(J1)
C RADIUS VECTOR FOR PARTICLE
      X2=R2*(DCOS(L2)*DCOS(P2-L2+AVE2)-DSIN(L2)*DSIN(P2-L2+AVE2)
     **DCOS(J2))
      Y2=R2*(DSIN(L2)*DCOS(P2-L2+AVE2)+DCOS(L2)*DSIN(P2-L2+AVE2)
     **DCOS(J2))
      Z2=R2*DSIN(P2-L2+AVE2)*DSIN(J2)
C DISTANCE
      DELTA=DSQRT((X1-X2)**2+(Y1-Y2)**2+(Z1-Z2)**2)
C SCALAR PRODUCT R1*R2
      R1R2=X1*X2+Y1*Y2+Z1*Z2
C DIRECT PART
      RDIR=UNO/DELTA
C INDIRECT PART (PROBABLY THIS IS A WASTE OF TIME)
      RIND=-R1R2/R1**3
C DISTURBING FUNCTION
      RPER=RDIR+RIND
C SUMATION FOR A CRUDE INTEGRAL
      RTOT=RTOT+RPER
      ENDDO
      RTOT=RTOT/DFLOAT(IPASOS)
C NOW MULTIPLY BY MASS_PLANET/MASS_JUPITER
        RP(ISI)=RTOT*SM(INPLA)/SM(5)
C TO OBTAIN STANDARD UNITS MULTIPLY RP BY MASS_JUPITER*KGAUSS**2
      ENDDO
C END OF LOOP FOR SIGMA
C FIND R_max AND R_min
      VRMAX=-999999.D0
      VRMIN=999999.D0
      DO I2=1,ISIMAX
        IF(RP(I2).LT.VRMIN) THEN
          VRMIN=RP(I2)
        ENDIF
        IF(RP(I2).GT.VRMAX) THEN
          VRMAX=RP(I2)
        ENDIF
      ENDDO
C CALCULATION OF MEAN VALUE <R>
      VMEDIO=0.D0
      DO I2=1,ISIMAX
        VMEDIO=VMEDIO+RP(I2)
      ENDDO
      VMEDIO=(VMEDIO)/DFLOAT(ISIMAX)
C VALUE OF <R>
      FME=VMEDIO
C VALUE OF THE STRENGTH SR
      FUE=VMEDIO-VRMIN
      WRITE(2,7)INPLA,dabs(NPQ),dabs(NP),SALSEM,EXC,YNC,ARGPER,FME,FUE
      WRITE(*,*)SALSEM,EXC,FUE
  333 CONTINUE
      WRITE(2,*) '  '
      CLOSE(2)
    7 FORMAT(I5,2F5.0,F9.4,F6.3,2F6.1,2F25.20)
      END
C********************************************************************

C ========================================================================
C SOLVING KEPLER
      SUBROUTINE SOLKEP(EX,M,E,NITER)
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 M,MK
      TOLE=1.D-12
      TWOPI=8.D0*DATAN(1.D0)
      M=DMOD(M,TWOPI)
      E=M
      NITER=0
 100  E0=E
      SE=DSIN(E0)
      CE=DCOS(E0)
      ES=EX*SE
      EC=1.D0-EX*CE
      MK=E0-ES
      U=(MK-M)/EC
      XPRI=E0-U
      XSEG=E0-U/(1.D0-U*ES)
      E=(XPRI+XSEG)/2.D0
      DEX=DABS(E-E0)
      NITER=NITER+1
C	 IF(NITER.GT.20)GOTO 200
      IF(DEX.GT.TOLE)GOTO 100
      RETURN
      END
C ========================================================================

